/**
 *
 * Copyright (c) 2007 Zurschmiede Lukas
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 *
 *
 * ComicMaker:ComicMaker_ComicImage
 * http://www.delight.ch/
 * Zurschmiede Lukas
 * delight software gmbh
 * Version 1.0 (05-07-2007)
 *
 **/
function ComicMaker_ComicImage(name, src, type) {
	var uid = new Date();
	this.src = src;
	this.type = type;
	this.name = name;
	this.image = new Image();
	this.image.src = src;
	this.image.id = name + uid.getTime();
	this.loadingError = false;
	this.loaded = false;
	Event.observe(this.image, 'error', imageLoading.error.bindAsEventListener(this));
	Event.observe(this.image, 'load', imageLoading.loaded.bindAsEventListener(this));
}

ComicMaker_ComicImage.prototype = {
	imageLoaded : function() {
		if (this.image.complete && !this.loaded) {
			this.loaded = true;
		} else if (this.loadingError) {
			this.loaded = true;
		}
		return this.loaded;
	},
	imageError : function() {
		return this.loadingError;
	},
	getChooser : function() {
		return this.type;
	},
	getName : function() {
		return this.name;
	},
	
	getImageSource : function() {
		return this.image.src;
	},
	getImageId : function() {
		return this.image.id;
	},
	
	last : null
};