/**
 *
 * Copyright (c) 2007 Zurschmiede Lukas
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 *
 *
 * ComicMaker:ComicMaker_ComicImage
 * http://www.delight.ch/
 * Zurschmiede Lukas
 * delight software gmbh
 * Version 1.0 (05-07-2007)
 *
 **/
function ComicMaker_ImagePreview(id, opt, optname) {
	this.contentId = id;
	this.opt = opt;
	this.optName = optname;
	this.width = this.opt.get(this.optName, 400, 'width');
	this.height = this.opt.get(this.optName, 350, 'height');
	this.imageOpt = {type:'',num:0,img:''};
	this.init();
}

ComicMaker_ImagePreview.prototype = {
	init : function() {
		if ($(this.contentId)) {
			var rotateLeft  = this.getRotateButton('left');
			var rotateRight = this.getRotateButton('right');
			var preview = this.getPreviewContainer();
			var content = '<table cellpadding="0" cellspacing="0" style="width:'+this.width+'px;height:'+this.height+'px;">' +
				'<tr><td colspan="2" id="'+preview.id+'_par"></td></tr>' +
				'<tr><td id="'+rotateLeft.id+'_par"></td><td id="'+rotateRight.id+'_par"></td></tr>' +
				'</table>';
			Element.extend($(this.contentId));
			$(this.contentId).update(content);
			
			rotateLeft = $(rotateLeft.id+'_par').appendChild(rotateLeft);
			rotateRight = $(rotateRight.id+'_par').appendChild(rotateRight);
			preview = $(preview.id+'_par').appendChild(preview);
			
			$(rotateLeft.id+'_par').addClassName('noborder middle left');
			$(rotateRight.id+'_par').addClassName('noborder middle right');
			$(preview.id+'_par').addClassName('noborder hiddenover');
			
			rotateLeft.addClassName('left');
			rotateRight.addClassName('right');
			preview.addClassName('center border middle');
			
			Event.observe(rotateLeft, 'mouseup', thumbnailClick.left.bindAsEventListener());
			Event.observe(rotateRight, 'mouseup', thumbnailClick.right.bindAsEventListener());
		}
	},
	
	getRotateButton : function(type) {
		var rotate = document.createElement('div');
		Element.extend(rotate);
		var img = new Image();
		img.src = 'images/layout/rotate'+type+'.png';
		rotate.innerHTML = '<img src="'+img.src+'" alt="'+type+'" />';
		rotate.id = 'ComicMaker_ImagePreview_rotate' + type;
		return rotate;
	},
	
	getPreviewContainer : function() {
		var cont = document.createElement('div');
		Element.extend(cont);
		cont.innerHTML = '&nbsp;';
		cont.id = 'ComicMaker_ImagePreview_preview';
		cont.style.height = (this.height - 25) + 'px';
		return cont;
	},
	
	showPreview : function(img, num, type) {
		if ($('ComicMaker_ImagePreview_preview')) {
			this.imageOpt.type = type;
			this.imageOpt.num = num;
			this.imageOpt.img = img.getName();
			var date = new Date();
			var id = 'img' + date.getTime();
			var width = img.image.width;
			var height = img.image.height;
			//var bgimg = ComicStage.stageElements[this.getCurrentImageType()].isBackground();
			
			if (width > parseInt($('ComicMaker_ImagePreview_preview').getWidth())) {
				width = parseInt($('ComicMaker_ImagePreview_preview').getWidth()) - 4;
			}
			if (height > parseInt($('ComicMaker_ImagePreview_preview').getHeight())) {
				height = parseInt($('ComicMaker_ImagePreview_preview').getHeight()) - 4;
			}
			$('ComicMaker_ImagePreview_preview').update('<img class="dragable" id="' + id + '" src="' + img.src + '" alt="'+img.getName()+'" longdesc="'+img.getChooser()+'" style="position:relative;width:'+width+'px;height:'+height+'px;" />');
			Event.observe(id, 'mouseover', thumbnailClick.click.bindAsEventListener());
		}
	},
	getCurrentImageNumber : function(type) {
		return this.imageOpt.num;
	},
	getCurrentImageType : function() {
		return this.imageOpt.type;
	},
	getCurrentImageCat : function() {
		return this.imageOpt.img;
	},
	
	last : null
};