/**
 *
 * Copyright (c) 2007 Zurschmiede Lukas
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 *
 *
 * djs_ContextMenu
 * http://www.delight.ch/
 * Zurschmiede Lukas
 * delight software gmbh
 * Version 1.0 (05-07-2007)
 *
 **/
function djs_ContextMenu() {
	this.options = new djs_Properties();
	this.show = false;
	this.id = new Date();
	this.id = 'men' + this.id.getTime();
	this.objectId = null;
}

djs_ContextMenu.prototype = {
	init : function(obj) {
		var menu = new Array();
		$H(obj).each(function(prop) {
			menu.push(prop.value);
		});
		this.options.set('menu', menu);
	},

	remove : function(name) {
		var menu = this.options.get('menu');
		var nmenu = new Array();
		for (var i = 0; i < menu.length; i++) {
			if (menu[i].name != name) {
				nmenu.push(menu[i]);
			}
		}
		this.options.set('menu', nmenu);
	},

	showMenu : function(x, y, cont, objid) {
		if (typeof(objid) != 'undefined') {
			this.objectId = objid;
		}

		if (this.show && $(this.id)) {
			$(this.id).style.left = x + 'px';
			$(this.id).style.top = y + 'px';
		} else {
			var obj = this;
			var html = '<table cellpadding="0" cellspacing="0">';
			this.options.get('menu',[]).each(function (param) {
				if (param.spacer) {
					html += '<tr><td class="icon" style="height:5px;">&nbsp;</td><td style="height:5px;"><hr size="1" noshadow="noshadow" /></td></tr>';
				} else {
					html += '<tr id="' + obj.id + '_' + param.name + '" onclick="callImageAction(\'' + obj.objectId + '\',\'' + param.name + '\')"><td class="icon"><img src="images/layout/' + param.icon + '" style="width:16px;height:16px;" alt=" " /></td><td>' + param.text + '</td></tr>';
				}
			});
			html += '</table>';

			var div = document.createElement('div');
			div.style.position = 'absolute';
			div.style.top = (y - 10) + 'px';
			div.style.left = (x - 10) + 'px';
			div.style.positon = 'block';
			div.style.zIndex = '9999';
			div.setAttribute('id', this.id);
			div.innerHTML = html;
			$(cont).appendChild(div);
			$(this.id).addClassName('contextmenu');
			this.show = true;
			contextMenuShow = this.objectId;

			Event.observe(window, 'click', imageEvents.doRemove);
			return true;
		}
	},

	removeMenu : function(id) {
		Event.stopObserving(window, 'click', imageEvents.doRemove);
		$(this.id).parentNode.removeChild($(this.id));
	},

	last : null
};
