/**
 *
 * Copyright (c) 2007 Zurschmiede Lukas
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use, copy,
 * modify, merge, publish, distribute, sublicense, and/or sell copies
 * of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 *
 *
 * ComicMaker BaseScript
 * http://www.delight.ch/
 * Zurschmiede Lukas
 * delight software gmbh
 * Version 1.0 (05-07-2007)
 *
 **/

function InitComicMaker() {
	ComicStage.init(ComicMaker_Properties);
	ComicStage.show();
}

var mouseCapture = {
	pos : function(e) {
		ComicStage.mouse.posX = Event.pointerX(e);
		ComicStage.mouse.posY = Event.pointerY(e);
	}
};
var imageLoading = {
	error : function(e) {
		//var tag = Event.element(e);
		//var arg = $A(arguments);
		//arg.shift();
		this.loadingError = true;
		ComicStage.chooserImageLoaded(this.getChooser(), this);
	},
	loaded : function(e) {
		this.loaded = true;
		ComicStage.chooserImageLoaded(this.getChooser(), this);
	}
};

var thumbnailClick = {
	preview : function(e) {
		var tag = Event.element(e);
		ComicStage.showPreviewImage(tag.getAttribute('longdesc'), tag.getAttribute('alt'), 0);
	},
	left : function(e) {
		var tag = Event.element(e);
		ComicStage.showPreviousPreviewImage();
	},
	right : function(e) {
		var tag = Event.element(e);
		ComicStage.showNextPreviewImage();
	},
	click : function(e) {
		var tag = Event.element(e);
		ComicStage.registerDraggable(tag.id);
	},
	release : function(e) {
		var tag = Event.element(e);
		ComicStage.unregisterDraggable(tag.id);
	}
	
};

// we need this in out Stage-IFrames to check if all Scripts are loaded
var lastJsLoaded = true;