var frameLoaded = false;
var lastJsLoaded = false;
var images = new Array();
var contextMenuShow = null;

function addImage(img, chooser, stage, posImg, posStg) {
	// Check if this is a Background or an Image
	if (chooser && chooser.opt.get(chooser.optName, false, 'background')) {
		setBackground(img.getAttribute('src'));
	} else {

		// Create a Stage-Image, append it to the list and show it
		var date = new Date();
		var simg = new ComicMaker_StageImage(img.getAttribute('name'), img.getAttribute('src'), stage);
		simg.setId('img' + date.getTime());
		simg.setPosition((posImg[0] - posStg[0]), (posImg[1] - posStg[1]));
		simg.setZIndex(500 + images.length);
		simg.setDimension(img.width, img.height);
		if (chooser && chooser.isEditable) {
			simg.setEditable(chooser.isEditable());
		} else {
			simg.setEditable(false);
		}
		if (chooser && chooser.isResizable) {
			simg.setResizable(chooser.isResizable());
		} else {
			simg.setResizable(true);
		}
		simg.showImage();
		images.push(simg);
	}
}
function restoreImage(imgSrc, imgName, stageId, imgId, zIndex, imgX, imgY, imgW, imgH, imgText, isPrintContent) {
	var simg = new ComicMaker_StageImage(imgName, imgSrc, stageId);
	simg.setId(imgId);
	simg.setPosition(imgX, imgY);
	simg.setZIndex(zIndex);
	simg.setDimension(imgW, imgH);
	simg.setEditable(false);
	simg.setResizable(true);
	simg.setIsPrintableContent(isPrintContent);
	if ((typeof(imgText) == 'string') && (imgText != '')) {
		simg.setEditable(true);
		simg.setImageText(imgText);
		simg.setResizable(false);
	}
	simg.showImage();
	images.push(simg);
}
function setBackground(imgSrc, isPrintContent) {
	if ( (typeof(isPrintContent) == 'undefined') || (typeof(isPrintContent) != 'boolean') || !isPrintContent ) {
		document.getElementsByTagName('body')[0].style.background = 'url('+imgSrc+') top left no-repeat';
	} else {
		if (imgSrc.length > 0) {
			var bg = document.createElement('img');
			bg.style.zIndex = 1;
			bg.style.position = 'absolute';
			bg.style.top = '0px';
			bg.style.left = '0px';
			bg.src = imgSrc;
			bg.id = 'bgimg1';
			document.getElementsByTagName('body')[0].appendChild(bg);

			window.setTimeout(function() {
				var bw = document.getElementsByTagName('body')[0].getDimensions().width;
				var bh = document.getElementsByTagName('body')[0].getDimensions().height;
				var iw = $('bgimg1').getDimensions().width;
				var ih = $('bgimg1').getDimensions().height;
				var bgWcount = 1;
				var bgHcount = 1;
				var elem, i, body = document.getElementsByTagName('body')[0];
				while (bgWcount * iw < bw) {
					elem = $('bgimg1').cloneNode(false);
					elem.id = 'bgimg' + (bgWcount + 1);
					elem.style.left = (bgWcount * iw) + 'px';
					body.appendChild(elem);
					bgWcount++;
				}
				while (bgHcount * ih < bh) {
					for (i = 0; i < bgWcount; i++) {
						elem = $('bgimg1').cloneNode(false);
						elem.id = 'bgimg' + (i+1) + (bgHcount + 1);
						elem.style.left = ((i+1) * iw) + 'px';
						elem.style.top = (bgHcount * ih) + 'px';
						body.appendChild(elem);
					}
					bgHcount++;
				}
			}, 100);

		}
	}
}
// Call an action an a Stage-Image
function callImageAction(id, action) {
	images.each(function(img) {
		if (img && img.getId() == id) {
			img.callAction(action);
		}
	});
}

// Return all IMages for a save request or a position-change of the stage
function getObjects() {
	var back = new Array();
	images.each(function (img) {
		back.push(img.getSaveObject());
	});
	var bgimg = document.getElementsByTagName('body')[0].style.backgroundImage;
	back.push({background:true, image:bgimg.substring(4, bgimg.length - 1)});
	return back;
}

// after loading, we need mostly all scripts which we loaded on parent
function loadParentScripts() {
	var scripts = parent.document.getElementsByTagName('script');
	var d = document, h = d.getElementsByTagName('head')[0], se, src;
	for (var i = 0; i < scripts.length; i++) {
		src = scripts[i].src;
		if ( (src.indexOf("/scriptaculous") < 0) && (src.indexOf("/prototype") < 0) && (src != "") && (!src.match(/(\/)(builder|controls|dragdrop|effects|slider|sound|tooltip|unittest)(\.js)/g)) ) {
			se = d.createElementNS('http://www.w3.org/1999/xhtml', 'script');
			se.setAttribute('language', 'javascript');
			se.setAttribute('type', 'text/javascript');
			se.setAttribute('src', src);
			h.appendChild(se);
		}
	}
}

// Events for Images which we must remove and insert some times
var imageEvents = {
	remove : function(e) {
		if (contextMenuShow != null) {
			images.each(function(img){
				if (img && img.getId() == contextMenuShow) {
					var id = Event.element(e).getAttribute('id');
					img.removeMenu(id);
				}
			});
			contextMenuShow = null;
		}
	},
	showMenu : function(e) {
		if (images && (e.which != 1) ) {
			var id = Event.element(e).getAttribute('id');
			images.each(function (img) {
				if (img.getId() == contextMenuShow) {
					img.removeMenu();
				}
			});
			images.each(function (img) {
				if (img.getId() == id) {
					img.showMenu(Event.pointerX(e), Event.pointerY(e));
				}
			});
			Event.stop(e);
		}
	},
	resizeImage : function(e) {
		var tag = Event.element(e);
		images.each(function(img) {
			if (img && img.isResizing && !$(tag).descendantOf(img.getId())) {
				img.callAction('removeresize');
			}
		});
	},
	resizeChangeSize : function(e) {
		var tag = Event.element(e);
		images.each(function(img) {
			if (img && img.resizeProcess) {
				img.callAction('doresize', Event.pointerX(e), Event.pointerY(e));
			}
		});
	},
	resizeEnd : function(e) {
		var tag = Event.element(e);
		images.each(function(img) {
			if (img && img.resizeProcess) {
				img.callAction('endresizing');
			}
		});
	},
	showTextEdit : function(e) {
		var tag = Event.element(e);
		var id = tag.getAttribute('id');
		images.each(function(img) {
			if (img && img.isEditable() && (id == img.getId())) {
				img.callAction('showedit');
			}
		});
	},
	hideTextEdit : function(e) {
		var tag = Event.element(e);
		var id = tag.getAttribute('id');
		images.each(function(img) {
			if (img && img.isEditable() && (id == 'edt'+img.getId())) {
				img.callAction('hideedit');
			}
		});
	},

	// NO EVENT-FUNCTIONS
	resizeProcess : function(imgid, action) {
		if (images[imgid] && !images[imgid].resizeProcess) {
			images[imgid].callAction('startresizing', action);
		}
		return false;
	}
};
imageEvents.doShowMenu = imageEvents.showMenu.bindAsEventListener(imageEvents);
imageEvents.doRemove = imageEvents.remove.bindAsEventListener(imageEvents);
imageEvents.doResizeImage = imageEvents.resizeImage.bindAsEventListener(imageEvents);
imageEvents.doResizeChangeSize = imageEvents.resizeChangeSize.bindAsEventListener(imageEvents);
imageEvents.doResizeEnd = imageEvents.resizeEnd.bindAsEventListener(imageEvents);
imageEvents.doShowTextEdit = imageEvents.showTextEdit.bindAsEventListener(imageEvents);
imageEvents.doHideTextEdit = imageEvents.hideTextEdit.bindAsEventListener(imageEvents);

function loaded() {
	if (lastJsLoaded && (typeof(ComicMaker_StageImage) != 'undefined') && (typeof(Draggable) != 'undefined')) {
		frameLoaded = true;
	} else {
		window.setTimeout("loaded()", 10);
	}
}
window.setTimeout("loaded()", 10);